/*
 * ORY Hydra - Cloud Native OAuth 2.0 and OpenID Connect Server
 *
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here. Keep in mind that this document reflects the latest branch, always. Support for versioned documentation is coming in the future.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.am
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

package swagger

import (
	"time"
)

type Certificate struct {
	AuthorityKeyId []int32 `json:"AuthorityKeyId,omitempty"`

	// BasicConstraintsValid indicates whether IsCA, MaxPathLen, and MaxPathLenZero are valid.
	BasicConstraintsValid bool `json:"BasicConstraintsValid,omitempty"`

	// CRL Distribution Points
	CRLDistributionPoints []string `json:"CRLDistributionPoints,omitempty"`

	// Subject Alternate Name values. (Note that these values may not be valid if invalid values were contained within a parsed certificate. For example, an element of DNSNames may not be a valid DNS domain name.)
	DNSNames []string `json:"DNSNames,omitempty"`

	EmailAddresses []string `json:"EmailAddresses,omitempty"`

	ExcludedDNSDomains []string `json:"ExcludedDNSDomains,omitempty"`

	ExcludedEmailAddresses []string `json:"ExcludedEmailAddresses,omitempty"`

	ExcludedIPRanges []IpNet `json:"ExcludedIPRanges,omitempty"`

	ExcludedURIDomains []string `json:"ExcludedURIDomains,omitempty"`

	ExtKeyUsage []ExtKeyUsage `json:"ExtKeyUsage,omitempty"`

	// Extensions contains raw X.509 extensions. When parsing certificates, this can be used to extract non-critical extensions that are not parsed by this package. When marshaling certificates, the Extensions field is ignored, see ExtraExtensions.
	Extensions []Extension `json:"Extensions,omitempty"`

	// ExtraExtensions contains extensions to be copied, raw, into any marshaled certificates. Values override any extensions that would otherwise be produced based on the other fields. The ExtraExtensions field is not populated when parsing certificates, see Extensions.
	ExtraExtensions []Extension `json:"ExtraExtensions,omitempty"`

	IPAddresses []Ip `json:"IPAddresses,omitempty"`

	IsCA bool `json:"IsCA,omitempty"`

	Issuer Name `json:"Issuer,omitempty"`

	IssuingCertificateURL []string `json:"IssuingCertificateURL,omitempty"`

	KeyUsage KeyUsage `json:"KeyUsage,omitempty"`

	// MaxPathLen and MaxPathLenZero indicate the presence and value of the BasicConstraints' \"pathLenConstraint\".  When parsing a certificate, a positive non-zero MaxPathLen means that the field was specified, -1 means it was unset, and MaxPathLenZero being true mean that the field was explicitly set to zero. The case of MaxPathLen==0 with MaxPathLenZero==false should be treated equivalent to -1 (unset).  When generating a certificate, an unset pathLenConstraint can be requested with either MaxPathLen == -1 or using the zero value for both MaxPathLen and MaxPathLenZero.
	MaxPathLen int64 `json:"MaxPathLen,omitempty"`

	// MaxPathLenZero indicates that BasicConstraintsValid==true and MaxPathLen==0 should be interpreted as an actual maximum path length of zero. Otherwise, that combination is interpreted as MaxPathLen not being set.
	MaxPathLenZero bool `json:"MaxPathLenZero,omitempty"`

	NotBefore time.Time `json:"NotBefore,omitempty"`

	// RFC 5280, 4.2.2.1 (Authority Information Access)
	OCSPServer []string `json:"OCSPServer,omitempty"`

	PermittedDNSDomains []string `json:"PermittedDNSDomains,omitempty"`

	// Name constraints
	PermittedDNSDomainsCritical bool `json:"PermittedDNSDomainsCritical,omitempty"`

	PermittedEmailAddresses []string `json:"PermittedEmailAddresses,omitempty"`

	PermittedIPRanges []IpNet `json:"PermittedIPRanges,omitempty"`

	PermittedURIDomains []string `json:"PermittedURIDomains,omitempty"`

	PolicyIdentifiers []ObjectIdentifier `json:"PolicyIdentifiers,omitempty"`

	PublicKey interface{} `json:"PublicKey,omitempty"`

	PublicKeyAlgorithm PublicKeyAlgorithm `json:"PublicKeyAlgorithm,omitempty"`

	Raw []int32 `json:"Raw,omitempty"`

	RawIssuer []int32 `json:"RawIssuer,omitempty"`

	RawSubject []int32 `json:"RawSubject,omitempty"`

	RawSubjectPublicKeyInfo []int32 `json:"RawSubjectPublicKeyInfo,omitempty"`

	RawTBSCertificate []int32 `json:"RawTBSCertificate,omitempty"`

	SerialNumber ModelInt `json:"SerialNumber,omitempty"`

	Signature []int32 `json:"Signature,omitempty"`

	SignatureAlgorithm SignatureAlgorithm `json:"SignatureAlgorithm,omitempty"`

	Subject Name `json:"Subject,omitempty"`

	SubjectKeyId []int32 `json:"SubjectKeyId,omitempty"`

	URIs []Url `json:"URIs,omitempty"`

	// UnhandledCriticalExtensions contains a list of extension IDs that were not (fully) processed when parsing. Verify will fail if this slice is non-empty, unless verification is delegated to an OS library which understands all the critical extensions.  Users can access these extensions using Extensions and can remove elements from this slice if they believe that they have been handled.
	UnhandledCriticalExtensions []ObjectIdentifier `json:"UnhandledCriticalExtensions,omitempty"`

	UnknownExtKeyUsage []ObjectIdentifier `json:"UnknownExtKeyUsage,omitempty"`

	Version int64 `json:"Version,omitempty"`
}
