# OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Certificate

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**authorityKeyId** | **[Number]** |  | [optional] 
**basicConstraintsValid** | **Boolean** | BasicConstraintsValid indicates whether IsCA, MaxPathLen, and MaxPathLenZero are valid. | [optional] 
**cRLDistributionPoints** | **[String]** | CRL Distribution Points | [optional] 
**dNSNames** | **[String]** | Subject Alternate Name values. (Note that these values may not be valid if invalid values were contained within a parsed certificate. For example, an element of DNSNames may not be a valid DNS domain name.) | [optional] 
**emailAddresses** | **[String]** |  | [optional] 
**excludedDNSDomains** | **[String]** |  | [optional] 
**excludedEmailAddresses** | **[String]** |  | [optional] 
**excludedIPRanges** | [**[IPNet]**](IPNet.md) |  | [optional] 
**excludedURIDomains** | **[String]** |  | [optional] 
**extKeyUsage** | [**[ExtKeyUsage]**](ExtKeyUsage.md) |  | [optional] 
**extensions** | [**[Extension]**](Extension.md) | Extensions contains raw X.509 extensions. When parsing certificates, this can be used to extract non-critical extensions that are not parsed by this package. When marshaling certificates, the Extensions field is ignored, see ExtraExtensions. | [optional] 
**extraExtensions** | [**[Extension]**](Extension.md) | ExtraExtensions contains extensions to be copied, raw, into any marshaled certificates. Values override any extensions that would otherwise be produced based on the other fields. The ExtraExtensions field is not populated when parsing certificates, see Extensions. | [optional] 
**iPAddresses** | [**[IP]**](IP.md) |  | [optional] 
**isCA** | **Boolean** |  | [optional] 
**issuer** | [**Name**](Name.md) |  | [optional] 
**issuingCertificateURL** | **[String]** |  | [optional] 
**keyUsage** | [**KeyUsage**](KeyUsage.md) |  | [optional] 
**maxPathLen** | **Number** | MaxPathLen and MaxPathLenZero indicate the presence and value of the BasicConstraints&#39; \&quot;pathLenConstraint\&quot;.  When parsing a certificate, a positive non-zero MaxPathLen means that the field was specified, -1 means it was unset, and MaxPathLenZero being true mean that the field was explicitly set to zero. The case of MaxPathLen&#x3D;&#x3D;0 with MaxPathLenZero&#x3D;&#x3D;false should be treated equivalent to -1 (unset).  When generating a certificate, an unset pathLenConstraint can be requested with either MaxPathLen &#x3D;&#x3D; -1 or using the zero value for both MaxPathLen and MaxPathLenZero. | [optional] 
**maxPathLenZero** | **Boolean** | MaxPathLenZero indicates that BasicConstraintsValid&#x3D;&#x3D;true and MaxPathLen&#x3D;&#x3D;0 should be interpreted as an actual maximum path length of zero. Otherwise, that combination is interpreted as MaxPathLen not being set. | [optional] 
**notBefore** | **Date** |  | [optional] 
**oCSPServer** | **[String]** | RFC 5280, 4.2.2.1 (Authority Information Access) | [optional] 
**permittedDNSDomains** | **[String]** |  | [optional] 
**permittedDNSDomainsCritical** | **Boolean** | Name constraints | [optional] 
**permittedEmailAddresses** | **[String]** |  | [optional] 
**permittedIPRanges** | [**[IPNet]**](IPNet.md) |  | [optional] 
**permittedURIDomains** | **[String]** |  | [optional] 
**policyIdentifiers** | [**[ObjectIdentifier]**](ObjectIdentifier.md) |  | [optional] 
**publicKey** | **Object** |  | [optional] 
**publicKeyAlgorithm** | [**PublicKeyAlgorithm**](PublicKeyAlgorithm.md) |  | [optional] 
**raw** | **[Number]** |  | [optional] 
**rawIssuer** | **[Number]** |  | [optional] 
**rawSubject** | **[Number]** |  | [optional] 
**rawSubjectPublicKeyInfo** | **[Number]** |  | [optional] 
**rawTBSCertificate** | **[Number]** |  | [optional] 
**serialNumber** | [**ModelInt**](ModelInt.md) |  | [optional] 
**signature** | **[Number]** |  | [optional] 
**signatureAlgorithm** | [**SignatureAlgorithm**](SignatureAlgorithm.md) |  | [optional] 
**subject** | [**Name**](Name.md) |  | [optional] 
**subjectKeyId** | **[Number]** |  | [optional] 
**uRIs** | [**[URL]**](URL.md) |  | [optional] 
**unhandledCriticalExtensions** | [**[ObjectIdentifier]**](ObjectIdentifier.md) | UnhandledCriticalExtensions contains a list of extension IDs that were not (fully) processed when parsing. Verify will fail if this slice is non-empty, unless verification is delegated to an OS library which understands all the critical extensions.  Users can access these extensions using Extensions and can remove elements from this slice if they believe that they have been handled. | [optional] 
**unknownExtKeyUsage** | [**[ObjectIdentifier]**](ObjectIdentifier.md) |  | [optional] 
**version** | **Number** |  | [optional] 


